import 'package:flutter/material.dart' show BuildContext;
import 'size_helper_source.dart';

extension SizeHelperBuildContext on BuildContext {
  T sizeHelper<T>({
    bool printScreenInfo = false,
    T? mobileSmall,
    T? mobileSmallLandscape,
    T? mobileNormal,
    T? mobileNormalLandscape,
    T? mobileLarge,
    T? mobileLargeLandscape,
    T? mobileExtraLarge,
    T? mobileExtraLargeLandscape,
    T? tabletSmall,
    T? tabletSmallLandscape,
    T? tabletNormal,
    T? tabletNormalLandscape,
    T? tabletLarge,
    T? tabletLargeLandscape,
    T? tabletExtraLarge,
    T? tabletExtraLargeLandscape,
    T? desktopSmall,
    T? desktopSmallLandscape,
    T? desktopNormal,
    T? desktopNormalLandscape,
    T? desktopLarge,
    T? desktopLargeLandscape,
    T? desktopExtraLarge,
    T? desktopExtraLargeLandscape,
  }) =>
      SizeHelper.of(this, printScreenInfo: printScreenInfo).help<T>(
        mobileSmall: mobileSmall,
        mobileSmallLandscape: mobileSmallLandscape,
        mobileNormal: mobileNormal,
        mobileNormalLandscape: mobileNormalLandscape,
        mobileLarge: mobileLarge,
        mobileLargeLandscape: mobileLargeLandscape,
        mobileExtraLarge: mobileExtraLarge,
        mobileExtraLargeLandscape: mobileExtraLargeLandscape,
        tabletSmall: tabletSmall,
        tabletSmallLandscape: tabletSmallLandscape,
        tabletNormal: tabletNormal,
        tabletNormalLandscape: tabletNormalLandscape,
        tabletLarge: tabletLarge,
        tabletLargeLandscape: tabletLargeLandscape,
        tabletExtraLarge: tabletExtraLarge,
        tabletExtraLargeLandscape: tabletExtraLargeLandscape,
        desktopSmall: desktopSmall,
        desktopSmallLandscape: desktopSmallLandscape,
        desktopNormal: desktopNormal,
        desktopNormalLandscape: desktopNormalLandscape,
        desktopLarge: desktopLarge,
        desktopLargeLandscape: desktopLargeLandscape,
        desktopExtraLarge: desktopExtraLarge,
        desktopExtraLargeLandscape: desktopExtraLargeLandscape,
      );

  T sizeHelperBuilder<T>({
    bool printScreenInfo = false,
    HelpBuilderCallback<T>? mobileSmall,
    HelpBuilderCallback<T>? mobileSmallLandscape,
    HelpBuilderCallback<T>? mobileNormal,
    HelpBuilderCallback<T>? mobileNormalLandscape,
    HelpBuilderCallback<T>? mobileLarge,
    HelpBuilderCallback<T>? mobileLargeLandscape,
    HelpBuilderCallback<T>? mobileExtraLarge,
    HelpBuilderCallback<T>? mobileExtraLargeLandscape,
    HelpBuilderCallback<T>? tabletSmall,
    HelpBuilderCallback<T>? tabletSmallLandscape,
    HelpBuilderCallback<T>? tabletNormal,
    HelpBuilderCallback<T>? tabletNormalLandscape,
    HelpBuilderCallback<T>? tabletLarge,
    HelpBuilderCallback<T>? tabletLargeLandscape,
    HelpBuilderCallback<T>? tabletExtraLarge,
    HelpBuilderCallback<T>? tabletExtraLargeLandscape,
    HelpBuilderCallback<T>? desktopSmall,
    HelpBuilderCallback<T>? desktopSmallLandscape,
    HelpBuilderCallback<T>? desktopNormal,
    HelpBuilderCallback<T>? desktopNormalLandscape,
    HelpBuilderCallback<T>? desktopLarge,
    HelpBuilderCallback<T>? desktopLargeLandscape,
    HelpBuilderCallback<T>? desktopExtraLarge,
    HelpBuilderCallback<T>? desktopExtraLargeLandscape,
  }) =>
      SizeHelper.of(this, printScreenInfo: printScreenInfo).helpBuilder(
        mobileSmall: mobileSmall,
        mobileSmallLandscape: mobileSmallLandscape,
        mobileNormal: mobileNormal,
        mobileNormalLandscape: mobileNormalLandscape,
        mobileLarge: mobileLarge,
        mobileLargeLandscape: mobileLargeLandscape,
        mobileExtraLarge: mobileExtraLarge,
        mobileExtraLargeLandscape: mobileExtraLargeLandscape,
        tabletSmall: tabletSmall,
        tabletSmallLandscape: tabletSmallLandscape,
        tabletNormal: tabletNormal,
        tabletNormalLandscape: tabletNormalLandscape,
        tabletLarge: tabletLarge,
        tabletLargeLandscape: tabletLargeLandscape,
        tabletExtraLarge: tabletExtraLarge,
        tabletExtraLargeLandscape: tabletExtraLargeLandscape,
        desktopSmall: desktopSmall,
        desktopSmallLandscape: desktopSmallLandscape,
        desktopNormal: desktopNormal,
        desktopNormalLandscape: desktopNormalLandscape,
        desktopLarge: desktopLarge,
        desktopLargeLandscape: desktopLargeLandscape,
        desktopExtraLarge: desktopExtraLarge,
        desktopExtraLargeLandscape: desktopExtraLargeLandscape,
      );
}
